diff --git a/src/backend/executor/nodeHash.c b/src/backend/executor/nodeHash.c
index 6a2f236..59fc07d 100644
--- a/src/backend/executor/nodeHash.c
+++ b/src/backend/executor/nodeHash.c
@@ -489,7 +489,7 @@ ExecChooseHashTableSize(double ntuples, int tupwidth, bool useskew,
 		/* We expect the hashtable to fit in memory */
 		double		dbuckets;
 
-		dbuckets = ceil(ntuples / NTUP_PER_BUCKET);
+		dbuckets = (hash_table_bytes / tupsize) / NTUP_PER_BUCKET;
 		dbuckets = Min(dbuckets, max_pointers);
 		nbuckets = (int) dbuckets;
 
